Having just laid out my plan for the next release of the Web Developer extension, now comes the news from Ben Goodger about the changes to extensions for Firefox 0.9.

These changes are very welcome as they should help to eliminate some of the issues surrounding extensions: incompatibilities with certain browser versions, lack of uninstall support, keeping track of extension updates to name just a few. However, these changes also have the potential to make the Firefox 0.9 release pretty messy. Basically, any extension written prior to 0.9 will not install under 0.9 and will need to be completely repackaged in order to work correctly going forward.

Changes = Work

This is going to result in many users becoming disgruntled when they find that some extensions have yet to be converted for Firefox 0.9. Of course, changes like this are to be expected from any pre–1.0 product, but I just hope that the resulting fallout is appropriately handled. Firstly, the code changes need to be rigorously tested so that all major bugs are resolved before the release or extension authors will be overwhelmed with support issues and trying to work out whether the problem is due to Firefox or the extension itself. Secondly, the extension authors need to be given adequate time to prepare their extensions both in terms of repackaging and setting them up on whatever server is going to handle tracking updates—currently suggested as being update.mozilla.org.

As I say, I am really looking forward to these changes as I think they greatly enhance the extension mechanism in Firefox, but I just hope that Ben is aware of how massive a change this is and works with the extension development community to mitigate the risks. There is a MozillaZine forums topic tracking the changes if you wish to read the latest news.

My Extensions

Now of course how this affects the User Agent Switcher and Web Developer extensions is hard to say until a release date for Firefox 0.9 is known. I have not been working on the User Agent Switcher extension recently, so I will just try to release a 0.9-compatible version when the browser release occurs. The Web Developer extension is trickier as I am currently working on the next version. However, my current plan is to keep working on it until Firefox 0.9 is released and then release whatever I have ready to go. This may mean that I don’t get to include everything I had hoped to in the Web Developer 0.8 release, but it will allow me to immediately release a 0.9-compatibile version.

Hopefully things will become clearer as the Firefox 0.9 release comes closer.